/*
 * BAMobile.js
 *
 * Olivier Castille
 * Copyright 2013, BMW Group
 *
 */


// Highlight and select a specified hotspot element in a GFX block
function selectHotspot(rootElementId, selectedIndex, target) {
    $('#' + rootElementId + ' .imageSearch-stepNumberRound').each(function (index, el) {
        if (index == selectedIndex) {
            if ($(el).attr('class') == ('imageSearch-stepNumberRound stepNumberRoundSelected') && target != '') {
                location.href = target;
            }
            $(el).attr('class', 'imageSearch-stepNumberRound stepNumberRoundSelected');
            $(el).parent().parent().attr('class', 'mapItem labelPositioned over');
        }
        else {
            $(el).attr('class', 'imageSearch-stepNumberRound');
            $(el).parent().parent().attr('class', 'mapItem labelPositioned');
        }
    });

    $('#' + rootElementId + ' li').each(function (index, el) {
        if (index == selectedIndex) {
            $(el).prev().attr('class', 'selectedPrev');
            $(el).attr('class', 'selected');
            if (isGFX() == true) {
                var position = $(el).offset().top - $(window).height() + 122
                console.log('position:' + position);
                if ($('h1').length != 0) {
                    position -= 66;
                }
                scrollTo(position);
            }
        }
        else {
            $(el).attr('class', '');
        }
    });
}


// Toggle a specified explanation element
function expandExplanation(element) {
    var explanationBackground = $(element).parent().next();
    if (explanationBackground.css('display') == 'block') {

        $(explanationBackground).slideToggle(500, function () {
            $(element).parent().parent().attr('class', 'element-box-inner explanation-box-inner');
            $(element).find('.explanation-up img').attr('src', 'resources/explanationUp.png');
        });
    }
    else {
        $(element).parent().parent().attr('class', 'element-box-inner explanation-box-inner element-box-inner-selected');
        $(element).find('.explanation-up img').attr('src', 'resources/explanationDown.png');
        $(explanationBackground).slideToggle(500, function () { });
    }
}


// Toggle a specified note element
var currentNoteBody;
function expandNote(element, isHeadElement) {
    if (currentNoteBody) {
        $(currentNoteBody).fadeOut(500);
        $(currentNoteBody).parent().find('.note-head').find('img').attr('src', 'resources/note.png');
    }

    var noteElement;
    if (isHeadElement) {
        noteElement = $(element).parent().parent();
    }
    else {
        noteElement = $(element).parent().parent().parent();
    }

    var noteHead = $(noteElement).find('.note-head');
    var noteBody = $(noteElement).find('.note-body');


    if (noteBody.css('display') == 'block') {
        $(noteBody).fadeOut(500); //.hide('fast');
        $(noteHead).find('img').attr('src', 'resources/note.png');
        currentNoteBody = null;
    }
    else {
        $(noteBody).fadeIn(500); //.show('fast');
        $(noteHead).find('img').attr('src', 'resources/noteOver.png');
        currentNoteBody = $(noteBody);
    }
}


// Define is current document is right to left direction
function isRTL() {
    return ($('html').attr('dir') == 'rtl');
}


// Toggle go up navigation element
function setGoUpVisibility(isVisible) {
    if (isVisible) {
        if (isRTL() == true) {
            $('.navigationGoUp').animate(
        	{
        	    left: '0px'
        	},
        	{
        	    queue: false,
        	    duration: 500
        	});
        }
        else {
            $('.navigationGoUp').animate(
        	{
        	    right: '0px'
        	},
        	{
        	    queue: false,
        	    duration: 500
        	});
        }

        clearTimeout(timerHide);
        timerHide = setTimeout("setGoUpVisibility(false)", 2500);
    }
    else {
        if (isRTL() == true) {
            $('.navigationGoUp').animate(
        	{
        	    left: '-120px'
        	},
        	{
        	    queue: false,
        	    duration: 500
        	});
        }
        else {
            $('.navigationGoUp').animate(
        	{
        	    right: '-120px'
        	},
        	{
        	    queue: false,
        	    duration: 500
        	});
        }
    }
}


// Toggle a specified warn and control explanation block
function expandWarnAndControlExplanation(el) {
    var contentEl = $(el).parent().parent().next();//.find(".content-exp");
    console.log(contentEl);
    if (contentEl.css('display') == 'block') {
        $(contentEl).slideToggle(500);
        $(el).find('td:eq(2) img').attr('src', 'resources/explanationUp.png');
    }
    else {
        $(contentEl).slideToggle(500);
        $(el).find('td:eq(2) img').attr('src', 'resources/explanationDown.png');
    }
}




// BOOKMARKS	
// Expand a specified bookmark to 2 different levels
function expandBookmark(elementId) {
    $('h2').each(function (index, el) {
        if ($(el).attr('id') == elementId) {
            var bookmarkDiv = $(el).next();
            var currentClass = bookmarkDiv.attr('class');
            if (currentClass == "bookmarkHidden shadow-box") {
                if (isRTL() == true) {
                    bookmarkDiv.attr('class', 'bookmarkVisible shadow-box').animate(
                	{
                	    left: '0px'
                	},
                	{
                	    queue: false,
                	    duration: 500
                	});
                }
                else {
                    bookmarkDiv.attr('class', 'bookmarkVisible shadow-box').animate(
                	{
                	    right: '0px'
                	},
                	{
                	    queue: false,
                	    duration: 500
                	});
                }


                bookmarkDiv.click(function () {
                    expandBookmark($(this).attr('id'));
                    return false;
                });
            }
            else if (currentClass == "bookmarkVisible shadow-box") {
                location.href = encodeURI("addbookmark://" + $(el).attr('id') + "|" + $.trim($(el).text()));

                bookmarkDiv.attr('class', 'bookmarkExpanded shadow-box');
                $(bookmarkDiv).find('#text').animate(
                {
                    margin: '11px'
                },
                {
                    queue: false,
                    duration: 500
                });
                setTimeout("collapseBookmark('" + elementId + "')", 2000);
            }
        }

    });

}

// Hide a specified bookmark
function collapseBookmark(elementId) {
    $('h2').each(function (index, el) {
        if ($(el).attr('id') == elementId) {
            var bookmarkDiv = $(el).next();
            $(bookmarkDiv).find('#text').animate(
            {
                margin: '11 -200 11 11'
            },
            {
                queue: true,
                duration: 400,
                complete: function () {
                    $(this).parent().attr('class', 'bookmarkVisible shadow-box').animate(
                    {
                        right: '-42'
                    },
                    {
                        queue: true,
                        duration: 100,
                        complete: function () {
                            $(this).attr('style', 'right:0px').attr('class', 'bookmarkDisabled shadow-box');
                        }
                    });
                }
            });
        }
    });
}


// Hide all bookmarks
function collapseAllVisibleBookmark() {
    $('h2').each(function (index, el) {
        var bookmarkDiv = $(el).next();
        var currentClass = bookmarkDiv.attr('class');
        if (currentClass == "bookmarkVisible shadow-box") {
            $(bookmarkDiv).animate(
            {
                right: '-42'
            },
            {
                queue: true,
                duration: 500,
                complete: function () {
                    $(this).attr('style', '').attr('class', 'bookmarkHidden shadow-box');
                }
            });
        }
    });
}


// Disable specified bookmarks and localize bookmark set label value
function disableBookmarks(bookmarksString, l10nBookmarkSetLabelValue) {
    var bookmarks = bookmarksString.split("|");
    $('h2').each(function (index, el) {
        var bookmarkDiv = $(el).next();
        if ($.inArray($(el).attr('id'), bookmarks) != -1) {
            $(bookmarkDiv).remove();
        }
        else {
            $(bookmarkDiv).children('#text').text(l10nBookmarkSetLabelValue);
        }
    });
}



// Zoom, set font size: 1, 2, 3, 4 or 5
function setFontSize(size, isTablet) {
    var additionnalPathValue = '';
    if (isTablet == '1' || isTablet == 'true' || isTablet == 'True') {
        additionnalPathValue = '-tablet';
    }


    if (size == '1' || size == '') {
        $('#cssSize').remove();
    }
    else {
        var cssPath = "resources/bam" + additionnalPathValue + "-" + size + ".css";
        if ($('#cssSize').attr('id')) {
            $('#cssSize').attr('href', cssPath);
        }
        else {
            $('head').append('<link id="cssSize" href="' + cssPath + '" media="screen, projection" rel="stylesheet" type="text/css">');
        }
    }

}





function isGFX() {
    return (document.location.href.indexOf("gfx") != -1);
}

// Update GFX page to allow legend to slide behind image which will be fix
function updateGFX() {
    // Get postion of body
    var body = $('.imageSearch-legend');
    var h1 = $('h1');
    var isH1Existing = (h1.length != 0);
    var head = $('.imageSearch-frame');

    var headTop = 0;
    var bodyTop = head.offset().top + head.height() + 5;

    if (isH1Existing) {
        bodyTop -= 5;
        headTop += 108;
    }

    // Update h1
    h1.css('position', 'fixed');

    // Update head
    head.css('position', 'fixed');
    head.css('background-color', 'white');
    head.css('width', '100%');
    head.css('z-index', '20');
    if (headTop > 0)
        head.css('top', headTop);

    // Update body
    body.css('top', head.offset().top + head.outerHeight() + 10);
    body.css('position', 'absolute');
    body.css('padding-bottom', '20px');

    // Disable go up navigation
    $('.navigationGoUp').remove();
}

// Reset offset
function scrollToTopFast() {
    scrollTo(0, 0);
}

// Scroll to top method
function scrollToTop() {
    scrollTo(0);
}

// Scroll to a defined position
function scrollTo(position) {
    scrollTo(position, 600);
}

// Scroll to a defined position with duration
function scrollTo(position, duration) {
    $("html, body").animate(
    {
        scrollTop: position
    }, duration);
}


// Scroll to a specified element
function scrollToId(elementId) {
    $('h0,h1,h2,h3,h4,h5,h6,h7').each(function (index, el) {
        if ($(el).attr('id') == elementId) {
            scrollTo($(el).offset().top - 15);
        }

    });

}

// Refresh slideshow images, iOS 7 fix
function refreshSlideshow() {
    $('.slideshow-content img').each(function (index, el) {
        var newSrc = $(this).attr('src') + '?' + new Date().getTime();
        $(this).attr('src', newSrc);
    });
}



// 	RUN TIME 
var timerHide;
var timerShow;
var timerBookmark;
$(document).ready(function () {

    var style = 'right:-120px';
    if (isRTL() == true)
        style = 'left:-120px';
    $('.navigationGoUp').attr('style', style);

    $(window).scroll(function () {
        // Go up navigation
        clearTimeout(timerShow);
        if (50 < $(window).scrollTop()) {
            timerShow = setTimeout("setGoUpVisibility(true)", 200);
        }

        // Bookmark
        clearTimeout(timerBookmark);
        timerBookmark = setTimeout("collapseAllVisibleBookmark()", 200);

        $('.element-box-inner ul li.hovered').removeClass('hovered');

    });

    $('.navigationGoUp').click(function () {
        scrollToTop();
        return false;
    });

    $('h2').click(function () {
        expandBookmark($(this).attr('id'));
        return false;
    });

    $('.bookmarkHidden').click(function () {
        expandBookmark($(this).prev().attr('id'));
        return false;
    });

    $('.element-box-inner ul li').bind('touchstart', function (e) {
        // remove Class if there is an element with class already applied
        $('.hovered').removeClass('hovered');
        // Apply your class to this
        $(this).addClass('hovered');
    });

    $('.element-box-inner ul li').bind('touchend', function (e) {
        // remove Class if there is an element with class already applied
        $('.hovered').removeClass('hovered');
        eval($(this).attr('action'));
    });

    // Update GFX page to allow legend to slide behind image which will be fix
    if (isGFX()) {
        setTimeout("updateGFX()", 100);
        scrollToTopFast();
    }

    $(".iwl-table").each(
        function () {
            if (!$(this).next().hasClass("content-exp") && $(this).parent().attr("id") == "contentBody") {
                var element = this.nextSibling;
                var container = $(this).nextAll("div.content-exp:first").find("table tbody tr td:nth-child(2)");
                while (!$(element).hasClass("content-exp")) {
                    var tomove = element;
                    element = this.nextSibling;
                    $(tomove).appendTo(container);
                }
            }
        });

})